# -*- coding: utf-8 -*-
#
# Copyright (c) 2015, Alcatel-Lucent Inc
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the copyright holder nor the names of its contributors
#       may be used to endorse or promote products derived from this software without
#       specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.



from .fetchers import NUMetadatasFetcher


from .fetchers import NUGlobalMetadatasFetcher


from .fetchers import NUSubnetsFetcher

from bambou import NURESTObject


class NUIKEGatewayConnection(NURESTObject):
    """ Represents a IKEGatewayConnection in the VSD

        Notes:
            Represents an IKE Gateway Connection object
    """

    __rest_name__ = "ikegatewayconnection"
    __resource_name__ = "ikegatewayconnections"

    
    ## Constants
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_APPD_SERVICE = "APPD_SERVICE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INFRASTRUCTURE_PORT_PROFILE = "INFRASTRUCTURE_PORT_PROFILE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EGRESS_QOS_PRIMITIVE = "EGRESS_QOS_PRIMITIVE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NSG_NOTIFICATION = "NSG_NOTIFICATION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DSCP_FORWARDING_CLASS_TABLE = "DSCP_FORWARDING_CLASS_TABLE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VPORTTAGTEMPLATE = "VPORTTAGTEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_APPLICATION = "APPLICATION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EVENT_LOG = "EVENT_LOG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_FLOATINGIP_ACL_ENTRY = "FLOATINGIP_ACL_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_BRIDGEINTERFACE = "BRIDGEINTERFACE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_KEYSERVER_NOTIFICATION = "KEYSERVER_NOTIFICATION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EXPORTIMPORT = "EXPORTIMPORT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_ACL_TEMPLATE_ENTRY = "INGRESS_ACL_TEMPLATE_ENTRY"
    
    CONST_NSG_IDENTIFIER_TYPE_ID_IPV4_ADDR = "ID_IPV4_ADDR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_IKE_GATEWAY_PROFILE = "IKE_GATEWAY_PROFILE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VIRTUAL_MACHINE_REPORT = "VIRTUAL_MACHINE_REPORT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_SECURITY_RESPONSE = "GATEWAY_SECURITY_RESPONSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_LDAP_CONFIG = "LDAP_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_KEYSERVER_MONITOR = "KEYSERVER_MONITOR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NSGATEWAY = "NSGATEWAY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ZONE_TEMPLATE = "ZONE_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_BGP_NEIGHBOR = "BGP_NEIGHBOR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_PERMITTED_ACTION = "PERMITTED_ACTION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VPORT_MIRROR = "VPORT_MIRROR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ESI_SEQUENCENO = "ESI_SEQUENCENO"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_VPORT_CONFIG = "GATEWAY_VPORT_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_APPD_EXTERNAL_APP_SERVICE = "APPD_EXTERNAL_APP_SERVICE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_LIBVIRT_INTERFACE = "LIBVIRT_INTERFACE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_SECURITY_REQUEST = "GATEWAY_SECURITY_REQUEST"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_PORT_MR = "PORT_MR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_BOOTSTRAP = "BOOTSTRAP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY = "GATEWAY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_BGP_NEIGHBOR_MED_RESPONSE = "BGP_NEIGHBOR_MED_RESPONSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SUBNET_POOL_ENTRY = "SUBNET_POOL_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ENTERPRISE_CONFIG = "ENTERPRISE_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_STATIC_ROUTE = "STATIC_ROUTE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SERVICE_VRF_SEQUENCENO = "SERVICE_VRF_SEQUENCENO"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_RTRD_SEQUENCENO = "RTRD_SEQUENCENO"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_MONITORING_PORT = "MONITORING_PORT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_BGP_DAMPENING_MED_RESPONSE = "BGP_DAMPENING_MED_RESPONSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VLAN = "VLAN"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DOMAIN_FLOATING_IP_ACL_TEMPLATE_ENTRY = "DOMAIN_FLOATING_IP_ACL_TEMPLATE_ENTRY"
    
    CONST_NSG_IDENTIFIER_TYPE_ID_FQDN = "ID_FQDN"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EGRESS_ACL_TEMPLATE = "EGRESS_ACL_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DHCP_OPTION = "DHCP_OPTION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EGRESS_ACL_TEMPLATE_ENTRY = "EGRESS_ACL_TEMPLATE_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NETWORK_MACRO_GROUP = "NETWORK_MACRO_GROUP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_ADV_FWD = "INGRESS_ADV_FWD"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NETWORK_ELEMENT = "NETWORK_ELEMENT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_HOSTINTERFACE = "HOSTINTERFACE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DOMAIN_CONFIG_RESP = "DOMAIN_CONFIG_RESP"
    
    CONST_ENTITY_SCOPE_GLOBAL = "GLOBAL"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NS_REDUNDANT_PORT = "NS_REDUNDANT_PORT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_IKE_ENCRYPTION_PROFILE = "IKE_ENCRYPTION_PROFILE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SITE_REQ = "SITE_REQ"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ENTERPRISE_CONFIG_RESP = "ENTERPRISE_CONFIG_RESP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_L2DOMAIN_TEMPLATE = "L2DOMAIN_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_BGP_PROFILE_MED_RESPONSE = "BGP_PROFILE_MED_RESPONSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VPORT_MEDIATION_REQUEST = "VPORT_MEDIATION_REQUEST"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SITE_RES = "SITE_RES"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VSG_REDUNDANT_PORT = "VSG_REDUNDANT_PORT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VPN_CONNECT = "VPN_CONNECT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VPORT = "VPORT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_APPD_TIER = "APPD_TIER"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_CHILD_ENTITY_POLICY_CHANGE = "CHILD_ENTITY_POLICY_CHANGE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_STATIC_ROUTE_RESP = "STATIC_ROUTE_RESP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_L2DOMAIN_SHARED = "L2DOMAIN_SHARED"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DOMAIN_CONFIG = "DOMAIN_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VMWARE_VCENTER_EAM_CONFIG = "VMWARE_VCENTER_EAM_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_EXT_SERVICE_TEMPLATE_ENTRY = "INGRESS_EXT_SERVICE_TEMPLATE_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ENTERPRISE = "ENTERPRISE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EVPN_BGP_COMMUNITY_TAG_ENTRY = "EVPN_BGP_COMMUNITY_TAG_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NATMAPENTRY = "NATMAPENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_UPLINK_RD = "UPLINK_RD"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_PATCONFIG_CONFIG_RESP = "PATCONFIG_CONFIG_RESP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_BGPPEER = "BGPPEER"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_KEYSERVER_MEMBER = "KEYSERVER_MEMBER"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NSPORT_STATIC_CONFIG = "NSPORT_STATIC_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VMWARE_VCENTER_DATACENTER = "VMWARE_VCENTER_DATACENTER"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NSPORT = "NSPORT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VPORT_GATEWAY_RESPONSE = "VPORT_GATEWAY_RESPONSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SYSTEM_CONFIG_REQ = "SYSTEM_CONFIG_REQ"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_BACK_HAUL_SERVICE_RESP = "BACK_HAUL_SERVICE_RESP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ENTERPRISE_SECURED_DATA = "ENTERPRISE_SECURED_DATA"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VSC = "VSC"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_IKE_SUBNET = "IKE_SUBNET"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_EXT_SERVICE = "INGRESS_EXT_SERVICE"
    
    CONST_NSG_IDENTIFIER_TYPE_ID_KEY_ID = "ID_KEY_ID"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_STATSSERVER = "STATSSERVER"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VMWARE_VRS_ADDRESS_RANGE = "VMWARE_VRS_ADDRESS_RANGE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ENDPOINT = "ENDPOINT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ENTERPRISE_PERMISSION = "ENTERPRISE_PERMISSION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VM_INTERFACE = "VM_INTERFACE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_HEALTH_REQ = "HEALTH_REQ"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_STATS_TCA = "STATS_TCA"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ZONE = "ZONE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_STATS_POLICY = "STATS_POLICY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_PATNATPOOL = "PATNATPOOL"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_IKE_GATEWAY = "IKE_GATEWAY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_JOB = "JOB"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_POLICING_POLICY = "POLICING_POLICY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_KEYSERVER_MONITOR_SEED = "KEYSERVER_MONITOR_SEED"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_UNSUPPORTED = "UNSUPPORTED"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DOMAIN_FLOATING_IP_ACL_TEMPLATE = "DOMAIN_FLOATING_IP_ACL_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_MULTI_NIC_VPORT = "MULTI_NIC_VPORT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VM_DESCRIPTION = "VM_DESCRIPTION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_SERVICE_CONFIG_RESP = "GATEWAY_SERVICE_CONFIG_RESP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NSPORT_TEMPLATE = "NSPORT_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EXTERNAL_SERVICE = "EXTERNAL_SERVICE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_METADATA = "METADATA"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VIRTUAL_IP = "VIRTUAL_IP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VSD_COMPONENT = "VSD_COMPONENT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_ADV_FWD_ENTRY = "INGRESS_ADV_FWD_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ROUTING_POLICY = "ROUTING_POLICY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_VPORT_CONFIG_RESP = "GATEWAY_VPORT_CONFIG_RESP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_CLOUD_MGMT_SYSTEM = "CLOUD_MGMT_SYSTEM"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_POLICY_DECISION = "POLICY_DECISION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DISKSTATS = "DISKSTATS"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EGRESS_QOS_MR = "EGRESS_QOS_MR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_APPD_FLOW_SECURITY_POLICY = "APPD_FLOW_SECURITY_POLICY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NETWORK_POLICY_GROUP = "NETWORK_POLICY_GROUP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NSGATEWAY_TEMPLATE = "NSGATEWAY_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ENTERPRISE_PROFILE = "ENTERPRISE_PROFILE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VMWARE_VCENTER_CLUSTER = "VMWARE_VCENTER_CLUSTER"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ACLENTRY_LOCATION = "ACLENTRY_LOCATION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_PORT_VLAN_CONFIG = "PORT_VLAN_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SHARED_RESOURCE = "SHARED_RESOURCE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_BGP_PROFILE = "BGP_PROFILE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_FLOATING_IP_ACL_TEMPLATE_ENTRY = "FLOATING_IP_ACL_TEMPLATE_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_IKE_GATEWAY_CONFIG = "IKE_GATEWAY_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_EXT_SERVICE_TEMPLATE = "INGRESS_EXT_SERVICE_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NODE_EXECUTION_ERROR = "NODE_EXECUTION_ERROR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NETWORK_LAYOUT = "NETWORK_LAYOUT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ADDRESS_RANGE = "ADDRESS_RANGE"
    
    CONST_ENTITY_SCOPE_ENTERPRISE = "ENTERPRISE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_PUBLIC_NETWORK = "PUBLIC_NETWORK"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_PORT = "PORT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NSPORT_VLAN_CONFIG = "NSPORT_VLAN_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SYSTEM_CONFIG_RESP = "SYSTEM_CONFIG_RESP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SYSTEM_CONFIG = "SYSTEM_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VM_RESYNC = "VM_RESYNC"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INFRASTRUCTURE_CONFIG = "INFRASTRUCTURE_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VMWARE_VCENTER_VRS_BASE_CONFIG = "VMWARE_VCENTER_VRS_BASE_CONFIG"
    
    CONST_NSG_ROLE_RESPONDER = "RESPONDER"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_SECURITY_PROFILE_REQUEST = "GATEWAY_SECURITY_PROFILE_REQUEST"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VLAN_TEMPLATE = "VLAN_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_MC_LIST = "MC_LIST"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_LOCATION = "LOCATION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_MIRROR_DESTINATION = "MIRROR_DESTINATION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_SERVICE_CONFIG = "GATEWAY_SERVICE_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_RATE_LIMITER = "RATE_LIMITER"
    
    CONST_NSG_IDENTIFIER_TYPE_ID_RFC822_ADDR = "ID_RFC822_ADDR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_POLICY_GROUP_TEMPLATE = "POLICY_GROUP_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SUBNET = "SUBNET"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_FLOATINGIP_ACL = "FLOATINGIP_ACL"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ROUTING_POL_MED_RESPONSE = "ROUTING_POL_MED_RESPONSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_RD_SEQUENCENO = "RD_SEQUENCENO"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_STATISTICS = "STATISTICS"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_SECURITY_PROFILE_RESPONSE = "GATEWAY_SECURITY_PROFILE_RESPONSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_WAN_SERVICE = "WAN_SERVICE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VMWARE_VCENTER_VRS_CONFIG = "VMWARE_VCENTER_VRS_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_PERMISSION = "PERMISSION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_IKE_PSK = "IKE_PSK"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SHAPING_POLICY = "SHAPING_POLICY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_CERTIFICATE = "CERTIFICATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_PORT_TEMPLATE = "PORT_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_METADATA_TAG = "METADATA_TAG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_POLICY_GROUP = "POLICY_GROUP"
    
    CONST_NSG_ROLE_INITIATOR = "INITIATOR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_KEYSERVER_MONITOR_SEK = "KEYSERVER_MONITOR_SEK"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SITE = "SITE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_ACL = "INGRESS_ACL"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_QOS_PRIMITIVE = "QOS_PRIMITIVE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_ACL_TEMPLATE = "INGRESS_ACL_TEMPLATE"
    
    CONST_NSG_IDENTIFIER_TYPE_ID_DER_ASN1_DN = "ID_DER_ASN1_DN"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_EXT_SERVICE_ENTRY = "INGRESS_EXT_SERVICE_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ENTERPRISE_NETWORK = "ENTERPRISE_NETWORK"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_ADV_FWD_TEMPLATE = "INGRESS_ADV_FWD_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_PORT_VLAN_CONFIG_RESPONSE = "PORT_VLAN_CONFIG_RESPONSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INFRASTRUCTURE_VSC_PROFILE = "INFRASTRUCTURE_VSC_PROFILE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_FLOATINGIP = "FLOATINGIP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VPORT_TAG_BASE = "VPORT_TAG_BASE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VMWARE_RELOAD_CONFIG = "VMWARE_RELOAD_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SERVICE_GATEWAY_RESPONSE = "SERVICE_GATEWAY_RESPONSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DOMAIN = "DOMAIN"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_TEMPLATE = "GATEWAY_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GROUPKEY_ENCRYPTION_PROFILE = "GROUPKEY_ENCRYPTION_PROFILE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DHCP_CONFIG_RESP = "DHCP_CONFIG_RESP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SYSTEM_MONITORING = "SYSTEM_MONITORING"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INFRASTRUCTURE_GATEWAY_PROFILE = "INFRASTRUCTURE_GATEWAY_PROFILE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_IKE_GATEWAY_CONNECTION = "IKE_GATEWAY_CONNECTION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SERVICES_GATEWAY_RESPONSE = "SERVICES_GATEWAY_RESPONSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_CONFIG = "GATEWAY_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GEO_VM_REQ = "GEO_VM_REQ"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GEO_VM_RES = "GEO_VM_RES"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ENTERPRISE_SECURITY = "ENTERPRISE_SECURITY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VPRN_LABEL_SEQUENCENO = "VPRN_LABEL_SEQUENCENO"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_REDUNDANT_GW_GRP = "REDUNDANT_GW_GRP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_RTRD_ENTITY = "RTRD_ENTITY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VRS = "VRS"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VMWARE_VCENTER = "VMWARE_VCENTER"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_AUTO_DISC_GATEWAY = "AUTO_DISC_GATEWAY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_APPD_FLOW_FORWARDING_POLICY = "APPD_FLOW_FORWARDING_POLICY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DC_CONFIG = "DC_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_LICENSE = "LICENSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VIRTUAL_MACHINE = "VIRTUAL_MACHINE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EVPN_BGP_COMMUNITY_TAG_SEQ_NO = "EVPN_BGP_COMMUNITY_TAG_SEQ_NO"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_CONTAINER_RESYNC = "CONTAINER_RESYNC"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_SECURED_DATA = "GATEWAY_SECURED_DATA"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_STATS_COLLECTOR = "STATS_COLLECTOR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_APPD_FLOW = "APPD_FLOW"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_PORT_PUSH = "PORT_PUSH"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_CUSTOMER_VRF_SEQUENCENO = "CUSTOMER_VRF_SEQUENCENO"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_BOOTSTRAP_ACTIVATION = "BOOTSTRAP_ACTIVATION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_SECURITY = "GATEWAY_SECURITY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_APPD_APPLICATION = "APPD_APPLICATION"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ADDRESS_RANGE_STATE = "ADDRESS_RANGE_STATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EGRESS_ACL_ENTRY = "EGRESS_ACL_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VMWARE_VCENTER_HYPERVISOR = "VMWARE_VCENTER_HYPERVISOR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_IKE_CERTIFICATE = "IKE_CERTIFICATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DHCP_ALLOC_MESSAGE = "DHCP_ALLOC_MESSAGE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_FLOATING_IP_ACL_TEMPLATE = "FLOATING_IP_ACL_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_ADV_FWD_TEMPLATE_ENTRY = "INGRESS_ADV_FWD_TEMPLATE_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DSCP_FORWARDING_CLASS_MAPPING = "DSCP_FORWARDING_CLASS_MAPPING"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NSGATEWAY_CONFIG = "NSGATEWAY_CONFIG"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NSREDUNDANT_GW_GRP = "NSREDUNDANT_GW_GRP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VSD = "VSD"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GEO_VM_EVENT = "GEO_VM_EVENT"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EGRESS_ACL = "EGRESS_ACL"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GATEWAY_CONFIG_RESP = "GATEWAY_CONFIG_RESP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VSP = "VSP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_HSC = "HSC"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SUBNET_ENTRY = "SUBNET_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_MC_CHANNEL_MAP = "MC_CHANNEL_MAP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SUBNET_MAC_ENTRY = "SUBNET_MAC_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_IP_BINDING = "IP_BINDING"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_GROUP = "GROUP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_USER = "USER"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_MC_RANGE = "MC_RANGE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ALARM = "ALARM"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_NEXT_HOP_RESP = "NEXT_HOP_RESP"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VLAN_CONFIG_RESPONSE = "VLAN_CONFIG_RESPONSE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_ENTITY_METADATA_BINDING = "ENTITY_METADATA_BINDING"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_KEYSERVER_MONITOR_ENCRYPTED_SEED = "KEYSERVER_MONITOR_ENCRYPTED_SEED"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_DOMAIN_TEMPLATE = "DOMAIN_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VNID_SEQUENCENO = "VNID_SEQUENCENO"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_SUBNET_TEMPLATE = "SUBNET_TEMPLATE"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_INGRESS_ACL_ENTRY = "INGRESS_ACL_ENTRY"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_L2DOMAIN = "L2DOMAIN"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_EGRESS_QOS_QUEUE_MR = "EGRESS_QOS_QUEUE_MR"
    
    CONST_ASSOCIATED_IKE_AUTHENTICATION_TYPE_VPORTTAG = "VPORTTAG"
    
    

    def __init__(self, **kwargs):
        """ Initializes a IKEGatewayConnection instance

            Notes:
                You can specify all parameters while calling this methods.
                A special argument named `data` will enable you to load the
                object from a Python dictionary

            Examples:
                >>> ikegatewayconnection = NUIKEGatewayConnection(id=u'xxxx-xxx-xxx-xxx', name=u'IKEGatewayConnection')
                >>> ikegatewayconnection = NUIKEGatewayConnection(data=my_dict)
        """

        super(NUIKEGatewayConnection, self).__init__()

        # Read/Write Attributes
        
        self._nsg_identifier = None
        self._nsg_identifier_type = None
        self._nsg_role = None
        self._name = None
        self._last_updated_by = None
        self._sequence = None
        self._allow_any_subnet = None
        self._unencrypted_psk = None
        self._entity_scope = None
        self._port_vlan_name = None
        self._priority = None
        self._associated_ike_authentication_id = None
        self._associated_ike_authentication_type = None
        self._associated_ike_encryption_profile_id = None
        self._associated_ike_gateway_profile_id = None
        self._associated_vlanid = None
        self._external_id = None
        
        self.expose_attribute(local_name="nsg_identifier", remote_name="NSGIdentifier", attribute_type=str, is_required=False, is_unique=False)
        self.expose_attribute(local_name="nsg_identifier_type", remote_name="NSGIdentifierType", attribute_type=str, is_required=False, is_unique=False, choices=[u'ID_DER_ASN1_DN', u'ID_FQDN', u'ID_IPV4_ADDR', u'ID_KEY_ID', u'ID_RFC822_ADDR'])
        self.expose_attribute(local_name="nsg_role", remote_name="NSGRole", attribute_type=str, is_required=False, is_unique=False, choices=[u'INITIATOR', u'RESPONDER'])
        self.expose_attribute(local_name="name", remote_name="name", attribute_type=str, is_required=False, is_unique=False)
        self.expose_attribute(local_name="last_updated_by", remote_name="lastUpdatedBy", attribute_type=str, is_required=False, is_unique=False)
        self.expose_attribute(local_name="sequence", remote_name="sequence", attribute_type=int, is_required=False, is_unique=False)
        self.expose_attribute(local_name="allow_any_subnet", remote_name="allowAnySubnet", attribute_type=bool, is_required=False, is_unique=False)
        self.expose_attribute(local_name="unencrypted_psk", remote_name="unencryptedPSK", attribute_type=str, is_required=False, is_unique=False)
        self.expose_attribute(local_name="entity_scope", remote_name="entityScope", attribute_type=str, is_required=False, is_unique=False, choices=[u'ENTERPRISE', u'GLOBAL'])
        self.expose_attribute(local_name="port_vlan_name", remote_name="portVLANName", attribute_type=str, is_required=False, is_unique=False)
        self.expose_attribute(local_name="priority", remote_name="priority", attribute_type=int, is_required=False, is_unique=False)
        self.expose_attribute(local_name="associated_ike_authentication_id", remote_name="associatedIKEAuthenticationID", attribute_type=str, is_required=False, is_unique=False)
        self.expose_attribute(local_name="associated_ike_authentication_type", remote_name="associatedIKEAuthenticationType", attribute_type=str, is_required=False, is_unique=False, choices=[u'ACLENTRY_LOCATION', u'ADDRESS_RANGE', u'ADDRESS_RANGE_STATE', u'ALARM', u'APPD_APPLICATION', u'APPD_EXTERNAL_APP_SERVICE', u'APPD_FLOW', u'APPD_FLOW_FORWARDING_POLICY', u'APPD_FLOW_SECURITY_POLICY', u'APPD_SERVICE', u'APPD_TIER', u'APPLICATION', u'AUTO_DISC_GATEWAY', u'BACK_HAUL_SERVICE_RESP', u'BGP_DAMPENING_MED_RESPONSE', u'BGP_NEIGHBOR', u'BGP_NEIGHBOR_MED_RESPONSE', u'BGP_PROFILE', u'BGP_PROFILE_MED_RESPONSE', u'BGPPEER', u'BOOTSTRAP', u'BOOTSTRAP_ACTIVATION', u'BRIDGEINTERFACE', u'CERTIFICATE', u'CHILD_ENTITY_POLICY_CHANGE', u'CLOUD_MGMT_SYSTEM', u'CONTAINER_RESYNC', u'CUSTOMER_VRF_SEQUENCENO', u'DC_CONFIG', u'DHCP_ALLOC_MESSAGE', u'DHCP_CONFIG_RESP', u'DHCP_OPTION', u'DISKSTATS', u'DOMAIN', u'DOMAIN_CONFIG', u'DOMAIN_CONFIG_RESP', u'DOMAIN_FLOATING_IP_ACL_TEMPLATE', u'DOMAIN_FLOATING_IP_ACL_TEMPLATE_ENTRY', u'DOMAIN_TEMPLATE', u'DSCP_FORWARDING_CLASS_MAPPING', u'DSCP_FORWARDING_CLASS_TABLE', u'EGRESS_ACL', u'EGRESS_ACL_ENTRY', u'EGRESS_ACL_TEMPLATE', u'EGRESS_ACL_TEMPLATE_ENTRY', u'EGRESS_QOS_MR', u'EGRESS_QOS_PRIMITIVE', u'EGRESS_QOS_QUEUE_MR', u'ENDPOINT', u'ENTERPRISE', u'ENTERPRISE_CONFIG', u'ENTERPRISE_CONFIG_RESP', u'ENTERPRISE_NETWORK', u'ENTERPRISE_PERMISSION', u'ENTERPRISE_PROFILE', u'ENTERPRISE_SECURED_DATA', u'ENTERPRISE_SECURITY', u'ENTITY_METADATA_BINDING', u'ESI_SEQUENCENO', u'EVENT_LOG', u'EVPN_BGP_COMMUNITY_TAG_ENTRY', u'EVPN_BGP_COMMUNITY_TAG_SEQ_NO', u'EXPORTIMPORT', u'EXTERNAL_SERVICE', u'FLOATING_IP_ACL_TEMPLATE', u'FLOATING_IP_ACL_TEMPLATE_ENTRY', u'FLOATINGIP', u'FLOATINGIP_ACL', u'FLOATINGIP_ACL_ENTRY', u'GATEWAY', u'GATEWAY_CONFIG', u'GATEWAY_CONFIG_RESP', u'GATEWAY_SECURED_DATA', u'GATEWAY_SECURITY', u'GATEWAY_SECURITY_PROFILE_REQUEST', u'GATEWAY_SECURITY_PROFILE_RESPONSE', u'GATEWAY_SECURITY_REQUEST', u'GATEWAY_SECURITY_RESPONSE', u'GATEWAY_SERVICE_CONFIG', u'GATEWAY_SERVICE_CONFIG_RESP', u'GATEWAY_TEMPLATE', u'GATEWAY_VPORT_CONFIG', u'GATEWAY_VPORT_CONFIG_RESP', u'GEO_VM_EVENT', u'GEO_VM_REQ', u'GEO_VM_RES', u'GROUP', u'GROUPKEY_ENCRYPTION_PROFILE', u'HEALTH_REQ', u'HOSTINTERFACE', u'HSC', u'IKE_CERTIFICATE', u'IKE_ENCRYPTION_PROFILE', u'IKE_GATEWAY', u'IKE_GATEWAY_CONFIG', u'IKE_GATEWAY_CONNECTION', u'IKE_GATEWAY_PROFILE', u'IKE_PSK', u'IKE_SUBNET', u'INFRASTRUCTURE_CONFIG', u'INFRASTRUCTURE_GATEWAY_PROFILE', u'INFRASTRUCTURE_PORT_PROFILE', u'INFRASTRUCTURE_VSC_PROFILE', u'INGRESS_ACL', u'INGRESS_ACL_ENTRY', u'INGRESS_ACL_TEMPLATE', u'INGRESS_ACL_TEMPLATE_ENTRY', u'INGRESS_ADV_FWD', u'INGRESS_ADV_FWD_ENTRY', u'INGRESS_ADV_FWD_TEMPLATE', u'INGRESS_ADV_FWD_TEMPLATE_ENTRY', u'INGRESS_EXT_SERVICE', u'INGRESS_EXT_SERVICE_ENTRY', u'INGRESS_EXT_SERVICE_TEMPLATE', u'INGRESS_EXT_SERVICE_TEMPLATE_ENTRY', u'IP_BINDING', u'JOB', u'KEYSERVER_MEMBER', u'KEYSERVER_MONITOR', u'KEYSERVER_MONITOR_ENCRYPTED_SEED', u'KEYSERVER_MONITOR_SEED', u'KEYSERVER_MONITOR_SEK', u'KEYSERVER_NOTIFICATION', u'L2DOMAIN', u'L2DOMAIN_SHARED', u'L2DOMAIN_TEMPLATE', u'LDAP_CONFIG', u'LIBVIRT_INTERFACE', u'LICENSE', u'LOCATION', u'MC_CHANNEL_MAP', u'MC_LIST', u'MC_RANGE', u'METADATA', u'METADATA_TAG', u'MIRROR_DESTINATION', u'MONITORING_PORT', u'MULTI_NIC_VPORT', u'NATMAPENTRY', u'NETWORK_ELEMENT', u'NETWORK_LAYOUT', u'NETWORK_MACRO_GROUP', u'NETWORK_POLICY_GROUP', u'NEXT_HOP_RESP', u'NODE_EXECUTION_ERROR', u'NS_REDUNDANT_PORT', u'NSG_NOTIFICATION', u'NSGATEWAY', u'NSGATEWAY_CONFIG', u'NSGATEWAY_TEMPLATE', u'NSPORT', u'NSPORT_STATIC_CONFIG', u'NSPORT_TEMPLATE', u'NSPORT_VLAN_CONFIG', u'NSREDUNDANT_GW_GRP', u'PATCONFIG_CONFIG_RESP', u'PATNATPOOL', u'PERMISSION', u'PERMITTED_ACTION', u'POLICING_POLICY', u'POLICY_DECISION', u'POLICY_GROUP', u'POLICY_GROUP_TEMPLATE', u'PORT', u'PORT_MR', u'PORT_PUSH', u'PORT_TEMPLATE', u'PORT_VLAN_CONFIG', u'PORT_VLAN_CONFIG_RESPONSE', u'PUBLIC_NETWORK', u'QOS_PRIMITIVE', u'RATE_LIMITER', u'RD_SEQUENCENO', u'REDUNDANT_GW_GRP', u'ROUTING_POL_MED_RESPONSE', u'ROUTING_POLICY', u'RTRD_ENTITY', u'RTRD_SEQUENCENO', u'SERVICE_GATEWAY_RESPONSE', u'SERVICE_VRF_SEQUENCENO', u'SERVICES_GATEWAY_RESPONSE', u'SHAPING_POLICY', u'SHARED_RESOURCE', u'SITE', u'SITE_REQ', u'SITE_RES', u'STATIC_ROUTE', u'STATIC_ROUTE_RESP', u'STATISTICS', u'STATS_COLLECTOR', u'STATS_POLICY', u'STATS_TCA', u'STATSSERVER', u'SUBNET', u'SUBNET_ENTRY', u'SUBNET_MAC_ENTRY', u'SUBNET_POOL_ENTRY', u'SUBNET_TEMPLATE', u'SYSTEM_CONFIG', u'SYSTEM_CONFIG_REQ', u'SYSTEM_CONFIG_RESP', u'SYSTEM_MONITORING', u'UNSUPPORTED', u'UPLINK_RD', u'USER', u'VIRTUAL_IP', u'VIRTUAL_MACHINE', u'VIRTUAL_MACHINE_REPORT', u'VLAN', u'VLAN_CONFIG_RESPONSE', u'VLAN_TEMPLATE', u'VM_DESCRIPTION', u'VM_INTERFACE', u'VM_RESYNC', u'VMWARE_RELOAD_CONFIG', u'VMWARE_VCENTER', u'VMWARE_VCENTER_CLUSTER', u'VMWARE_VCENTER_DATACENTER', u'VMWARE_VCENTER_EAM_CONFIG', u'VMWARE_VCENTER_HYPERVISOR', u'VMWARE_VCENTER_VRS_BASE_CONFIG', u'VMWARE_VCENTER_VRS_CONFIG', u'VMWARE_VRS_ADDRESS_RANGE', u'VNID_SEQUENCENO', u'VPN_CONNECT', u'VPORT', u'VPORT_GATEWAY_RESPONSE', u'VPORT_MEDIATION_REQUEST', u'VPORT_MIRROR', u'VPORT_TAG_BASE', u'VPORTTAG', u'VPORTTAGTEMPLATE', u'VPRN_LABEL_SEQUENCENO', u'VRS', u'VSC', u'VSD', u'VSD_COMPONENT', u'VSG_REDUNDANT_PORT', u'VSP', u'WAN_SERVICE', u'ZONE', u'ZONE_TEMPLATE'])
        self.expose_attribute(local_name="associated_ike_encryption_profile_id", remote_name="associatedIKEEncryptionProfileID", attribute_type=str, is_required=False, is_unique=False)
        self.expose_attribute(local_name="associated_ike_gateway_profile_id", remote_name="associatedIKEGatewayProfileID", attribute_type=str, is_required=False, is_unique=False)
        self.expose_attribute(local_name="associated_vlanid", remote_name="associatedVLANID", attribute_type=str, is_required=False, is_unique=False)
        self.expose_attribute(local_name="external_id", remote_name="externalID", attribute_type=str, is_required=False, is_unique=True)
        

        # Fetchers
        
        
        self.metadatas = NUMetadatasFetcher.fetcher_with_object(parent_object=self, relationship="child")
        
        
        self.global_metadatas = NUGlobalMetadatasFetcher.fetcher_with_object(parent_object=self, relationship="child")
        
        
        self.subnets = NUSubnetsFetcher.fetcher_with_object(parent_object=self, relationship="child")
        

        self._compute_args(**kwargs)

    # Properties
    
    @property
    def nsg_identifier(self):
        """ Get nsg_identifier value.

            Notes:
                NSG Identifier. Null to take on the default 'uuid'

                
                This attribute is named `NSGIdentifier` in VSD API.
                
        """
        return self._nsg_identifier

    @nsg_identifier.setter
    def nsg_identifier(self, value):
        """ Set nsg_identifier value.

            Notes:
                NSG Identifier. Null to take on the default 'uuid'

                
                This attribute is named `NSGIdentifier` in VSD API.
                
        """
        self._nsg_identifier = value

    
    @property
    def nsg_identifier_type(self):
        """ Get nsg_identifier_type value.

            Notes:
                NSG Identifier Type. 

                
                This attribute is named `NSGIdentifierType` in VSD API.
                
        """
        return self._nsg_identifier_type

    @nsg_identifier_type.setter
    def nsg_identifier_type(self, value):
        """ Set nsg_identifier_type value.

            Notes:
                NSG Identifier Type. 

                
                This attribute is named `NSGIdentifierType` in VSD API.
                
        """
        self._nsg_identifier_type = value

    
    @property
    def nsg_role(self):
        """ Get nsg_role value.

            Notes:
                NSG role

                
                This attribute is named `NSGRole` in VSD API.
                
        """
        return self._nsg_role

    @nsg_role.setter
    def nsg_role(self, value):
        """ Set nsg_role value.

            Notes:
                NSG role

                
                This attribute is named `NSGRole` in VSD API.
                
        """
        self._nsg_role = value

    
    @property
    def name(self):
        """ Get name value.

            Notes:
                Optional Name of the connection

                
        """
        return self._name

    @name.setter
    def name(self, value):
        """ Set name value.

            Notes:
                Optional Name of the connection

                
        """
        self._name = value

    
    @property
    def last_updated_by(self):
        """ Get last_updated_by value.

            Notes:
                ID of the user who last updated the object.

                
                This attribute is named `lastUpdatedBy` in VSD API.
                
        """
        return self._last_updated_by

    @last_updated_by.setter
    def last_updated_by(self, value):
        """ Set last_updated_by value.

            Notes:
                ID of the user who last updated the object.

                
                This attribute is named `lastUpdatedBy` in VSD API.
                
        """
        self._last_updated_by = value

    
    @property
    def sequence(self):
        """ Get sequence value.

            Notes:
                

                
        """
        return self._sequence

    @sequence.setter
    def sequence(self, value):
        """ Set sequence value.

            Notes:
                

                
        """
        self._sequence = value

    
    @property
    def allow_any_subnet(self):
        """ Get allow_any_subnet value.

            Notes:
                Allow any local subnets to be used

                
                This attribute is named `allowAnySubnet` in VSD API.
                
        """
        return self._allow_any_subnet

    @allow_any_subnet.setter
    def allow_any_subnet(self, value):
        """ Set allow_any_subnet value.

            Notes:
                Allow any local subnets to be used

                
                This attribute is named `allowAnySubnet` in VSD API.
                
        """
        self._allow_any_subnet = value

    
    @property
    def unencrypted_psk(self):
        """ Get unencrypted_psk value.

            Notes:
                Unencrypted PSK

                
                This attribute is named `unencryptedPSK` in VSD API.
                
        """
        return self._unencrypted_psk

    @unencrypted_psk.setter
    def unencrypted_psk(self, value):
        """ Set unencrypted_psk value.

            Notes:
                Unencrypted PSK

                
                This attribute is named `unencryptedPSK` in VSD API.
                
        """
        self._unencrypted_psk = value

    
    @property
    def entity_scope(self):
        """ Get entity_scope value.

            Notes:
                Specify if scope of entity is Data center or Enterprise level

                
                This attribute is named `entityScope` in VSD API.
                
        """
        return self._entity_scope

    @entity_scope.setter
    def entity_scope(self, value):
        """ Set entity_scope value.

            Notes:
                Specify if scope of entity is Data center or Enterprise level

                
                This attribute is named `entityScope` in VSD API.
                
        """
        self._entity_scope = value

    
    @property
    def port_vlan_name(self):
        """ Get port_vlan_name value.

            Notes:
                The Name of the Port and Vlan the IKEv2 Connection is on

                
                This attribute is named `portVLANName` in VSD API.
                
        """
        return self._port_vlan_name

    @port_vlan_name.setter
    def port_vlan_name(self, value):
        """ Set port_vlan_name value.

            Notes:
                The Name of the Port and Vlan the IKEv2 Connection is on

                
                This attribute is named `portVLANName` in VSD API.
                
        """
        self._port_vlan_name = value

    
    @property
    def priority(self):
        """ Get priority value.

            Notes:
                Priority of the IKEv2 Gateway Connection

                
        """
        return self._priority

    @priority.setter
    def priority(self, value):
        """ Set priority value.

            Notes:
                Priority of the IKEv2 Gateway Connection

                
        """
        self._priority = value

    
    @property
    def associated_ike_authentication_id(self):
        """ Get associated_ike_authentication_id value.

            Notes:
                Associated Authentication ID

                
                This attribute is named `associatedIKEAuthenticationID` in VSD API.
                
        """
        return self._associated_ike_authentication_id

    @associated_ike_authentication_id.setter
    def associated_ike_authentication_id(self, value):
        """ Set associated_ike_authentication_id value.

            Notes:
                Associated Authentication ID

                
                This attribute is named `associatedIKEAuthenticationID` in VSD API.
                
        """
        self._associated_ike_authentication_id = value

    
    @property
    def associated_ike_authentication_type(self):
        """ Get associated_ike_authentication_type value.

            Notes:
                Associated Authentication Type

                
                This attribute is named `associatedIKEAuthenticationType` in VSD API.
                
        """
        return self._associated_ike_authentication_type

    @associated_ike_authentication_type.setter
    def associated_ike_authentication_type(self, value):
        """ Set associated_ike_authentication_type value.

            Notes:
                Associated Authentication Type

                
                This attribute is named `associatedIKEAuthenticationType` in VSD API.
                
        """
        self._associated_ike_authentication_type = value

    
    @property
    def associated_ike_encryption_profile_id(self):
        """ Get associated_ike_encryption_profile_id value.

            Notes:
                The ID of the associated IKEEncryptionProfile

                
                This attribute is named `associatedIKEEncryptionProfileID` in VSD API.
                
        """
        return self._associated_ike_encryption_profile_id

    @associated_ike_encryption_profile_id.setter
    def associated_ike_encryption_profile_id(self, value):
        """ Set associated_ike_encryption_profile_id value.

            Notes:
                The ID of the associated IKEEncryptionProfile

                
                This attribute is named `associatedIKEEncryptionProfileID` in VSD API.
                
        """
        self._associated_ike_encryption_profile_id = value

    
    @property
    def associated_ike_gateway_profile_id(self):
        """ Get associated_ike_gateway_profile_id value.

            Notes:
                The ID of the associated IKEGatewayProfile

                
                This attribute is named `associatedIKEGatewayProfileID` in VSD API.
                
        """
        return self._associated_ike_gateway_profile_id

    @associated_ike_gateway_profile_id.setter
    def associated_ike_gateway_profile_id(self, value):
        """ Set associated_ike_gateway_profile_id value.

            Notes:
                The ID of the associated IKEGatewayProfile

                
                This attribute is named `associatedIKEGatewayProfileID` in VSD API.
                
        """
        self._associated_ike_gateway_profile_id = value

    
    @property
    def associated_vlanid(self):
        """ Get associated_vlanid value.

            Notes:
                The ID of the associated Vlan

                
                This attribute is named `associatedVLANID` in VSD API.
                
        """
        return self._associated_vlanid

    @associated_vlanid.setter
    def associated_vlanid(self, value):
        """ Set associated_vlanid value.

            Notes:
                The ID of the associated Vlan

                
                This attribute is named `associatedVLANID` in VSD API.
                
        """
        self._associated_vlanid = value

    
    @property
    def external_id(self):
        """ Get external_id value.

            Notes:
                External object ID. Used for integration with third party systems

                
                This attribute is named `externalID` in VSD API.
                
        """
        return self._external_id

    @external_id.setter
    def external_id(self, value):
        """ Set external_id value.

            Notes:
                External object ID. Used for integration with third party systems

                
                This attribute is named `externalID` in VSD API.
                
        """
        self._external_id = value

    

    